xmpp-rs/xmpp
Repository files (latest commit first)
Filename Latest commit message Latest commit date
Jonas Schäfer fc8b581593 Clean up tls-related feature flags
This provides a clear and consistent interface for selecting TLS-related
features on both (xmpp and tokio-xmpp) crates. All feature checks have
been revamped. All working combinations have been tested (including a
connectivity test + --all-features docs build) using:

```
set -xeuo pipefail
features=(aws_lc_rs ring ktls,aws_lc_rs ktls,ring aws_lc_rs,ring aws_lc_rs,ring,ktls native-tls rustls-any-backend)
export RUSTFLAGS=" -D warnings"
cargo test --no-default-features
cargo test
for feature in ${features[@]}; do
  echo ">>> BUILDING with $feature" 2>&1
  # Running code or building examples cannot succeed with rustls-any-backend.
  features="starttls,$feature"
  if [ "$feature" != 'rustls-any-backend' ]; then
    if ! cargo test --no-default-features --features="$features"; then
      echo ">>> BUILD FAILED for tls feature set: $features" >&2
      exit 1
    fi
    set +e
    timeout -sINT -p -k 2 3 cargo run --no-default-features --features="$features" --example keep_connection -- test@hub.sotecware.net "$(pass xmpp/test@hub.sotecware.net)"
    status="$?"
    set -e
    if [ $status -ne 0 ]; then
      echo ">>> keep_connection did not shut down cleanly! (status: $status)" >&2
      exit 1
    fi
  else
    if ! cargo build --no-default-features --features="$feature"; then
      echo ">>> BUILD FAILED for tls feature set: $features" >&2
      exit 1
    fi
  fi
done
RUSTDOCFLAGS="--cfg docsrs" RUSTFLAGS="--cfg xmpprs_doc_build" cargo +nightly doc -Zrustdoc-map --all-features
```
2025-05-10 22:02:39 +02:00
..
examples Clean up tls-related feature flags 2025-05-10 22:02:39 +02:00
src Clean up tls-related feature flags 2025-05-10 22:02:39 +02:00
Cargo.toml Clean up tls-related feature flags 2025-05-10 22:02:39 +02:00
ChangeLog Clean up tls-related feature flags 2025-05-10 22:02:39 +02:00
LICENSE Remove the -rs suffix of jid, minidom and xmpp 2020-06-22 02:17:32 +02:00
README.md Finish removing 'rs' suffix in libs 2020-07-15 10:49:50 +02:00

xmpp

What's this?

A very much WIP rust XMPP library with the goals of being type-safe and well-tested.

Contact

There is an XMPP MUC for the discussion of this library, feel free to join! :)

chat@xmpp.rs

License

Mozilla Public License 2 (MPL2). See the LICENSE file.